<template>
    <div class="card-row">
        <div class="card-row__wrapper">
            <div class="card-row__header">
                <div class="card-row__column" v-if="$interface.viewport !== 'mobile'">
                    <SVGIcon class="card-row__bank-icon"
                             :xlink="bankLocal.icon"
                             viewBox="0 0 70 45"/>
                </div>
                <div class="card-row__column card-row__column-info">
                    <input v-if="edit"
                           class="card-row__input"
                           placeholder="Введите имя карты"
                           :value="bankLocal.name"
                           v-on:blur="unfocusEdit"
                           ref="cardName"/>
                    <div v-else class="card-row__name"
                         v-on:click="focusEdit">{{bankLocal.name}}
                    </div>
                </div>
                <div class="card-row__column card-row__column-info">
                    <div class="card-row__payment-system">
                        <SVGIcon class="card-row__payment-system-icon"
                                 :xlink="system.icon"
                                 viewBox="0 0 35 35"/>
                        {{card.number}}
                    </div>
                </div>
                <div v-if="main" class="card-row__column card-row__column-info card-row__will-be-issued-here">
                    <div class="card-row__string">
                        <SVGIcon class="card-row__string-green-icon"
                                 xlink="check-mark"
                                 viewBox="0 0 20 20"/>
                        <span class="card-row__string-green-text">Займ будет выдан на эту карту</span>
                    </div>
                </div>
            </div>
            <div class="card-row__footer">
                <div v-if="bound && !card.automaticPayment" class="card-row__footer-button">
                    <SVGIcon class="card-row__footer-button-icon" xlink="acceptance-expand-24" viewBox="0 0 24 24"/>
                    <div class="link blue" v-on:click="openAutomaticPayment">Добавить автоплатеж</div>
                </div>
                <div v-else-if="!bound" class="card-row__footer-button">
                    <SVGIcon class="card-row__footer-button-icon" xlink="attention-20" viewBox="0 0 20 20"/>
                    <div class="card-row__footer-bound-it">Карта не привязана <a class="link blue" href="">привязать</a></div>
                </div>
                <div v-else-if="bound && card.automaticPayment" class="next-automatic-payment" v-on:click="openAutomaticPayment">
                    <span>Списание {{card.automaticPayment.date}}</span>
                    <span v-if="visibleAutomaticPayment" class="link blue">закрыть</span>
                    <span v-else class="link blue">изменить</span>
                </div>
                <div class="card-row__footer-buttons-holder">
                    <div class="card-row__footer-button-in-holder" v-if="!main && !bound">Сделать основной</div>
                    <div class="card-row__footer-button-in-holder" v-if="remove">Удалить карту</div>
                </div>
            </div>
            <transition name="fade">
                <AutomaticPayment v-if="visibleAutomaticPayment" :automaticPayment="card.automaticPayment"/>
            </transition>
        </div>
    </div>
</template>

<script>
    import SVGIcon from "../SVGIcon/index";
    import AutomaticPayment from "../../pages/AllCards/AutomaticPayment";

    export default {
        name: "CardRow",
        props: ['card', 'bank', 'system', 'bound', 'main', 'remove'],
        components: {
            AutomaticPayment,
            SVGIcon
        },
        data() {
            return {
                bankLocal: null,
                edit: false,
                visibleAutomaticPayment: false
            }
        },
        created() {
            this.bankLocal = this.bank;
        },
        methods: {
            focusEdit() {
                this.edit = true;
                this.$nextTick(() => {
                    this.$refs.cardName.focus();
                });
            },
            unfocusEdit() {
                this.edit = false;
            },
            openAutomaticPayment() {
                if (this.visibleAutomaticPayment) {
                    this.visibleAutomaticPayment = false;
                } else {
                    this.visibleAutomaticPayment = true;
                }
            }
        }
    }
</script>